routes/web.php
<?php

use App\Http\Controllers\EpisodesController;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\SeasonsController;
use App\Http\Controllers\SeriesController;
use App\Http\Controllers\UsersController;
use App\Http\Middleware\Authenticator;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', fn () => redirect('/series'))->middleware(Authenticator::class);

Route::resource('/series', SeriesController::class)
    ->except(['show']);

Route::middleware('authenticator')->group(function () {
    Route::get('/series/{series}/seasons', [SeasonsController::class, 'index'])
        ->name('seasons.index');

    Route::get('/seasons/{season}/episodes', [EpisodesController::class, 'index'])
        ->name('episodes.index');

    Route::post('/seasons/{season}/episodes', [EpisodesController::class, 'update'])
        ->name('episodes.update');
});

Route::get('/login', [LoginController::class, 'index'])
    ->name('login');

Route::post('/login', [LoginController::class, 'store'])
    ->name('login.store');

Route::get('/logout', [LoginController::class, 'destroy'])
    ->name('logout');

Route::get('/register', [UsersController::class, 'create'])
    ->name('users.create');

Route::post('/register', [UsersController::class, 'store'])
    ->name('users.store');

app/Models/Episode.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Episode extends Model
{
    use HasFactory;

    protected $fillable = ['number'];

    public $timestamps = false;

    public function season()
    {
        return $this->belongsTo(Season::class);
    }
}

app/Models/Season.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Season extends Model
{
    use HasFactory;

    protected $fillable = ['number'];

    public function series()
    {
        return $this->belongsTo(Series::class);
    }

    public function episodes()
    {
        return $this->hasMany(Episode::class);
    }

    public function numWatchedEpisodes(): int
    {
        return $this->episodes
            ->filter(fn (Episode $episode) => $episode->watched)
            ->count();
    }
}

app/Models/Series.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Series extends Model
{
    use HasFactory;
    protected $fillable = ['name'];

    public function seasons()
    {
        return $this->hasMany(Season::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/EpisodesController.php
<?php

namespace App\Http\Controllers;

use App\Models\Episode;
use App\Models\Season;
use Illuminate\Http\Request;

class EpisodesController
{
    public function index(Season $season)
    {
        return view('episodes.index')
            ->with('episodes', $season->episodes)
            ->with('success', session('mensagem.sucesso'));
    }

    public function update(Request $request, Season $season)
    {
        $watchedEpisodes = $request->episodes;
        $season->episodes->each(function (Episode $episode) use ($watchedEpisodes) {
            $episode->watched = in_array($episode->id, $watchedEpisodes);
        });

        $season->push();

        return to_route('episodes.index', $season->id)
            ->with('mensagem.sucesso', 'Episódios marcados como assistidos');
    }
}

app/Http/Controllers/LoginController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class LoginController
{
    public function index()
    {
        return view('login.index');
    }

    public function store(Request $request)
    {
        if (!Auth::attempt($request->only(['email', 'password'])))
        {
            return redirect()->back()->withErrors(['Usuário ou senha inválidos']);
        }

        return to_route('series.index');
    }

    public function destroy()
    {
        Auth::logout();

        return to_route('login');
    }
}

app/Http/Controllers/SeasonsController.php
<?php

namespace App\Http\Controllers;

use App\Models\Series;

class SeasonsController extends Controller
{
    public function index(Series $series)
    {
        $seasons = $series->seasons()
            ->with('episodes')
            ->get();

        return view('seasons.index')
            ->with('seasons', $seasons)
            ->with('series', $series);
    }
}

app/Http/Controllers/SeriesController.php
<?php

namespace App\Http\Controllers;

use App\Http\Middleware\Authenticator;
use App\Http\Requests\SeriesFormRequest;
use App\Models\Series;
use App\Repositories\SeriesRepository;

class SeriesController extends Controller
{
    public function __construct(private SeriesRepository $repository)
    {
        $this->middleware(Authenticator::class)->except('index');
    }

    public function index()
    {
        $seriesList = Series::query()->orderBy('name')->get();
        $success = session('message.success');

        return view('series.index')
            ->with('seriesList', $seriesList)
            ->with('success', $success);
    }

    public function create()
    {
        return view('series.create');
    }

    public function store(SeriesFormRequest $request)
    {
        $series = $this->repository->add($request);

        return to_route('series.index')
            ->with('message.success', "Série \"{$series->name}\" adicionada com sucesso");
    }

    public function destroy(Series $series)
    {
        $series->delete();

        return to_route('series.index')
            ->with('message.success', "Série \"{$series->name}\" removida com sucesso");
    }

    public function edit(Series $series)
    {
        return view('series.edit')
            ->with('series', $series);
    }

    public function update(Series $series, SeriesFormRequest $request)
    {
        $series->fill($request->all());
        $series->save();

        return to_route('series.index')
            ->with('message.success', "Série \"{$series->name}\" atualizada com sucesso");
    }
}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;

class UsersController
{
    public function create()
    {
        return view('users.create');
    }

    public function store(Request $request)
    {
        $data = $request->except(['_token']);
        $data['password'] = Hash::make($data['password']);

        $user = User::create($data);

        Auth::login($user);

        return to_route('series.index');
    }
}

resources/views/episodes/index.blade.php
<x-layout title="Episódios" :success="$success">
    <form method="post">
        @csrf
        <ul class="list-group">
            @foreach ($episodes as $episode)
                <li class="list-group-item d-flex justify-content-between align-items-center">
                    Episódio {{ $episode->number }}
                    <input type="checkbox" name="episodes[]" value="{{ $episode->id }}"
                        @if ($episode->watched) checked @endif>
                </li>
            @endforeach
        </ul>
        <button type="submit" class="btn btn-primary my-2">Salvar</button>
    </form>
</x-layout>

resources/views/login/index.blade.php
<x-layout title="Login">
    <form method="post">
        @csrf
        <div class="form-group">
            <label for="email" class="form-label">Email:</label>
            <input type="email" name="email" id="email" class="form-control">
        </div>
        <div class="form-group">
            <label for="password" class="form-label">Senha:</label>
            <input type="password" name="password" id="password" class="form-control">
        </div>
        <button type="submit" class="btn btn-primary mt-3">Login</button>
        <a href="{{ route('users.create') }}" class="btn btn-secondary mt-3">Registrar</a>
    </form>
</x-layout>

resources/views/seasons/index.blade.php
<x-layout title='Temporadas de "{!! $series->name !!}"'>
    <ul class="list-group">
        @foreach ($seasons as $season)
            <li class="list-group-item d-flex justify-content-between align-items-center">
                <a href="{{ route('episodes.index', $season->id) }}">
                    Temporada {{ $season->number }}
                </a>
                <div class="badge bg-secondary">
                    {{ $season->numWatchedEpisodes() }} | {{ $season->episodes->count() }}
                </div>
            </li>
        @endforeach
    </ul>
</x-layout>

resources/views/series/create.blade.php
<x-layout title="Criar nova Série">
    <form action="{{ route('series.store') }}" method="post">
        @csrf

        <div class="row mb-3">
            <div class="col-8">
                <label for="name" class="form-label">Nome da Série:</label>
                <input type="text" name="name" id="name" class="form-control" value="{{ old('name') }}">
            </div>
            <div class="col-2">
                <label for="seasons_quantity" class="form-label">Número de Temporadas:</label>
                <input type="number " name="seasons_quantity" id="seasons_quantity" class="form-control" value="{{ old('seasons_quantity') }}">
            </div>
            <div class="col-2">
                <label for="episodes_per_season" class="form-label">Número de episódios:</label>
                <input type="number" name="episodes_per_season" id="episodes_per_season" class="form-control" value="{{ old('episodes_per_season') }}">
            </div>
        </div>
        <button type="submit" class="btn btn-primary">Criar Série</button>
    </form>
    <a href="{{ route('series.index') }}" class="btn btn-secondary mt-2">Listar todas as Séries</a>
</x-layout>

resources/views/series/edit.blade.php
<x-layout title='Editar Série "{!! $series->name !!}"'>
    <form action="{{ route('series.update', $series->id) }}" method="post">
        @csrf
        @method('PUT')
        <div class="mb-3">
            <label for="name" class="form-label">Nome da Série:</label>
            <input type="text" name="name" id="name" class="form-control" value="{{ old('name') }}">
        </div>
        <button type="submit" class="btn btn-primary">Atualizar Série</button>
    </form>
    <a href="{{ route('series.index') }}" class="btn btn-secondary mt-2">Listar todas as Séries</a>
</x-layout>

resources/views/series/index.blade.php
<x-layout title="Lista de Séries" :success="$success">
    @auth
        <a class="btn btn-primary mb-2" href="{{ route('series.create') }}">Criar nova série</a>
    @endauth
    <ul class="list-group">
        @foreach ($seriesList as $series)
            <li class="list-group-item d-flex justify-content-between align-items-center">
                @auth<a href="{{ route('seasons.index', $series->id) }}">@endauth{{ $series->name }}@auth</a>@endauth
                @auth
                    <div class="d-flex gap-2">
                        <a href="{{ route('series.edit', $series->id) }}" class="btn btn-success btn-sm">Editar</a>
                        <form action="{{ route('series.destroy', $series->id) }}" method="post">
                            @csrf
                            @method('DELETE')
                            <button class="btn btn-danger btn-sm">
                                Deletar
                            </button>
                        </form>
                    </div>
                @endauth
            </li>
        @endforeach
    </ul>
</x-layout>

resources/views/users/create.blade.php
<x-layout title="Registrar">
    <form method="post">
        @csrf
        <div class="form-group">
            <label for="name" class="form-label">Nome:</label>
            <input type="text" name="name" id="name" class="form-control">
        </div>
        <div class="form-group">
            <label for="email" class="form-label">Email:</label>
            <input type="email" name="email" id="email" class="form-control">
        </div>
        <div class="form-group">
            <label for="password" class="form-label">Senha:</label>
            <input type="password" name="password" id="password" class="form-control">
        </div>
        <button type="submit" class="btn btn-primary mt-3">Registrar</button>
        <a href="{{ route('login') }}" class="btn btn-secondary mt-3">Login</a>
    </form>
</x-layout>